Add missing libGLESv1_CM.so to Bionic

Bug #1782285 reported by Yogish Kulkarni on 2018-07-18
18
This bug affects 2 people
Affects Status Importance Assigned to Milestone
libglvnd (Ubuntu)
Undecided
Timo Aaltonen
Bionic
Undecided
Timo Aaltonen

Bug Description

[Impact]
GLESv1 support was not enabled in libglvnd

[Test case]
install libgles1, see that the library is available

[Regression potential]
none, it's a new package

--

libGLESv1_CM.so is provided by GLVND project. This binary is missing in Bionic. It is also not listed under libglvnd source package in Bionic: https://launchpad.net/ubuntu/bionic/+source/libglvnd

This bug is to know if this was unintentional ? in that case can it be generated for Bionic-updates ?

affects: mesa (Ubuntu) → libglvnd (Ubuntu)
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in libglvnd (Ubuntu):
status: New → Confirmed
Timo Aaltonen (tjaalton) wrote :

it was intentionally left out, because mesa doesn't provide it anymore

Kyle Brenneman (kyle-brenneman) wrote :

Just because Mesa doesn't provide GLESv1 doesn't mean other vendor libraries can't. It certainly isn't any reason to prohibit GLESv1 support if a vendor library would otherwise be able to support it.

Conversely, having the full set of libglvnd libraries (including libGLESv1_CM.so) doesn't require vendors to support every flavor of OpenGL.

If you remove libGLESv1_CM.so, then any driver that does support GLESv1 would have to install its own copy of that library. Two drivers that support GLESv1 would then end up overwriting each other or playing symlink games to switch between them. The whole point of libglvnd is to avoid that.

Timo Aaltonen (tjaalton) wrote :

my understanding of GLESv1 is that it was only used on fixed-function GPU's which we don't support anyway, correct me if I'm wrong..

Sandeep (sashinde) wrote :

Yes GLESv1 is a fixed-function pipeline but all the modern day GPUs still do support it along with support for more recent GLESv2 (programmable pipeline)

With current glvnd libs on 18.04, even if a GPU supports GLESv1 in HW and SW, apps can't use the API due to missing libGLESv1_CM.so

Timo Aaltonen (tjaalton) wrote :

fair enough, the packaging followed fedora, which added gles1 support back after the first upload to sid

Sandeep (sashinde) wrote :

Thanks Timo.

Can you please update on when should we expect glvnd-gles1 to be back ported to Bionic?

Also if a new package is going to be built, can we make sure we take a change in glvnd-egl reported as issue in https://bugs.launchpad.net/ubuntu/+source/libglvnd/+bug/1780039.

Kyle Brenneman (kyle-brenneman) wrote :

Also, while GLESv1 is the fixed-pipeline stuff, libGLESv1_CM.so just provides a set of forwarder functions. Libglvnd forwards those calls to a vendor library based on the current context, so it's up to the vendor library what to do with them. If a vendor doesn't provide a function to forward to, then libglvnd sends the function to an error or no-op stub (the same way it would handle calling a function without a current context at all).

For something like GLESv1, if a vendor library doesnt't support it, then it would just return NULL from its eglCreateConext or glXCreateContextAttribsARB implementation. At that point, the vendor library doesn't need to implement any of the GLESv1 functions -- trying to call a GLESv1 function without a current GLESv1 context is an application error.

tags: removed: upgrade-software-version
Changed in libglvnd (Ubuntu):
assignee: nobody → Timo Aaltonen (tjaalton)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libglvnd - 1.0.0+git20180308-4

---------------
libglvnd (1.0.0+git20180308-4) unstable; urgency=medium

  * rules, libgles2: Add GLESv1 support. (LP: #1782285)

 -- Timo Aaltonen <email address hidden> Wed, 08 Aug 2018 13:41:21 +0300

Changed in libglvnd (Ubuntu):
status: Confirmed → Fix Released
Sandeep (sashinde) wrote :

Thanks Timo.

Can you please update on when this package be made available for Bionic?

Timo Aaltonen (tjaalton) wrote :

soon, 1.1.0-1 will have libgles1 on it's own package and that needs to go through NEW first, then the package added to the version in bionic

Gabor Nagy (g-nagy) wrote :

This cause package conflict with nvidia-340.

The other libglvnd libraries would already cause a conflict with nvidia-340, wouldn't they?

The actual release tag (plus tarball and release notes) is here:
https://github.com/NVIDIA/libglvnd/releases/tag/v1.1.0

Changed in libglvnd (Ubuntu Bionic):
assignee: nobody → Timo Aaltonen (tjaalton)
Timo Aaltonen (tjaalton) wrote :

libglvnd update for this and the other issue is on the queue

Changed in libglvnd (Ubuntu Bionic):
status: New → In Progress
Łukasz Zemczak (sil2100) wrote :

This needs to have all the required SRU information filled out in the description before a proper queue review can happen. Thank yoU!

Timo Aaltonen (tjaalton) on 2018-08-23
description: updated
Sandeep (sashinde) wrote :

Hi,
Is there update on when will we see glvnd v1.1.0 released for bionic?
Thanks.

Timo Aaltonen (tjaalton) wrote :

1.1.0 won't get there, but there's a version with backported commits to fix this and another bug on the queue

Hello Yogish, or anyone else affected,

Accepted libglvnd into bionic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/libglvnd/1.0.0-2ubuntu2.2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-bionic to verification-done-bionic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-bionic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in libglvnd (Ubuntu Bionic):
status: In Progress → Fix Committed
tags: added: verification-needed verification-needed-bionic
Yogish Kulkarni (yogishk) wrote :

Verified that libGLESv1_CM.so gets installed after installing libglvnd0 from bionic-proposed.

To upgrade libglvnd0, I did following:
1) Add "deb http://ports.ubuntu.com/ubuntu-ports bionic-proposed restricted main multiverse universe" in /etc/apt/sources.list
2) sudo apt-get update
3) sudo apt-get install --only-upgrade libglvnd0

After doing above verified that libGLESv1_CM.so get installed:
$ ls -lh /usr/lib/aarch64-linux-gnu/libGLESv1*
lrwxrwxrwx 1 root root 21 Aug 15 06:20 /usr/lib/aarch64-linux-gnu/libGLESv1_CM.so -> libGLESv1_CM.so.1.0.0
lrwxrwxrwx 1 root root 21 Aug 15 06:20 /usr/lib/aarch64-linux-gnu/libGLESv1_CM.so.1 -> libGLESv1_CM.so.1.0.0
-rw-r--r-- 1 root root 139K Aug 15 06:20 /usr/lib/aarch64-linux-gnu/libGLESv1_CM.so.1.0.0

libglvnd version that was verified to have libGLESv1_CM.so:
$ apt-cache policy libglvnd0
libglvnd0:
  Installed: 1.0.0-2ubuntu2.2
  Candidate: 1.0.0-2ubuntu2.2
  Version table:
 *** 1.0.0-2ubuntu2.2 500
        500 http://ports.ubuntu.com/ubuntu-ports bionic-proposed/main arm64 Packages
        100 /var/lib/dpkg/status
     1.0.0-2ubuntu2.1 500
        500 http://ports.ubuntu.com/ubuntu-ports bionic-updates/main arm64 Packages
     1.0.0-2ubuntu2 500
        500 http://ports.ubuntu.com/ubuntu-ports bionic/main arm64 Packages

tags: added: verification-done-bionic
removed: verification-needed verification-needed-bionic

The verification of the Stable Release Update for libglvnd has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libglvnd - 1.0.0-2ubuntu2.2

---------------
libglvnd (1.0.0-2ubuntu2.2) bionic; urgency=medium

  * rules, libgles2: Add GLESv1 support. (LP: #1782285)
  * Always return an error from eglMakeCurrent if EGLDisplay is invalid.
    (LP: #1780039)

 -- Timo Aaltonen <email address hidden> Wed, 15 Aug 2018 09:20:42 +0300

Changed in libglvnd (Ubuntu Bionic):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers